// runtime.cc

#ifdef MINIMAL
void Bomb(const char*s);
extern "C" {

    char mallocBuffer[99999];
    int mallocPointer;
    void* malloc( int n ) { n= (n+3)&0xFFFFFFFC; void*z= mallocBuffer+mallocPointer; mallocPointer+=n; return z; }
    void free( const void* ) { }

    int __gxx_personality_v0;
    int __cxa_pure_virtual;

    void _Unwind_Resume() {}
    void abort() { Bomb("abort"); }

    extern const char* filedata[];

    extern int read( int fd, void* buf, int sz);
    extern int write( int fd, const void* buf, int sz);
}

bool StrEq(const char* s, const char* t) { int i;
    for (i=0; s[i] && t[i]; i++) {
	if ( s[i] != t[i] ) return false;
    }
    return s[i] == t[i];
}

int SYSopen( const char* name, int mode ) {
    for ( const char** p= filedata;  *p;  p+=2 ) {
	if ( StrEq( name, *p ) ) {
	    return (int)(p[1]);
	}
    }
    return -1;
}
int SYSread(int fd, char* buf, int sz) {

    if (fd==0) return read(0, buf, sz);

    for (int i=0; i<sz; i++) {
	buf[i]= ((char*)fd)[i];
	if ( buf[i]=='\0' ) return i;
    }
    return sz;
}
int SYSclose(int fd) {
    return 0;
}
int SYSwrite( int fd, const void* buf, int sz)
{
    return write( fd, buf, sz );
}

#else
#include <malloc.h>
#include <stdio.h>
#include <unistd.h>

#define SYSopen open
#define SYSread read
#define SYSwrite write
#define SYSclose close
#endif

int count_new;
int count_delete;
int count_new_array;
int count_delete_array;

void* operator new( unsigned n ) {
    ++ count_new;
    void* p= malloc(n);
//fprintf(stderr,"\nM %d %d\n", p, n );
    return p;
}
void* operator new [] ( unsigned n ) {
    ++ count_new_array;
    void* p= malloc(n);
//fprintf(stderr,"\nMA %d %d\n", p, n );
    return p;
}

void operator delete(void* p) {
    ++ count_delete;
//fprintf(stderr,"\nD %d\n", p );
    free(p);
}
void operator delete [] (void* p) {
    ++ count_delete_array;
//fprintf(stderr,"\nDA %d\n", p );
    free(p);
}




int StrLen(const char* s);

int PutcStdout( int c ) 
{
    char ch= (char) c;
    int cc= SYSwrite( 1, &ch, 1 );
    return ! (cc==1);
}

int PutcStderr( int c ) 
{
    char ch= (char) c;
    int cc= SYSwrite( 2, &ch, 1 );
    return ! (cc==1);
}


int PutsStdout( const char buf[], int len )
{
    int cc= SYSwrite( 1, buf, len );
    return ! (cc==len);
}

int PutsStderr( const char buf[], int len )
{
    int cc= SYSwrite( 2, buf, len );
    return ! (cc==len);
}

static char* CRASH= 0;  // dereferencing NULL will bomb us
void Bomb(const char*s)
{
    char* banner= "\nBOMBING: ";
    PutsStderr( banner, StrLen(banner) );

    PutsStderr( s, StrLen(s) );
    PutcStderr( '\n' );
    PutcStderr( *CRASH );
}

// END
